#!/bin/bash
#
# 請修改phpv變數後再執行操作
# WP主機需另外進行php新版本相關設定
#
# ex.2024-12-12

phpv='php84'
phpvn='8.4'

# 安裝alt-php套件
yum install alt-"$phpv"* -y
#yum groupinstall alt-"$phpv" -y
#yum groupinstall alt-"$phpv" --enablerepo=cloudlinux-updates-testing

# 將新版alt-php改成lsapi
/usr/local/cpanel/bin/rebuild_phpconf --alt-"$phpv"=lsapi

# 設定 Default PHP Version 與各 PHP 版本預設的模組
#selectorctl --replace-extensions=bcmath,dom,fileinfo,gd,imap,intl,mbstring,mysqlnd,pdo,pdo_mysql,pdo_sqlite,phar,posix,snmp,soap,sockets,tidy,xmlreader,xmlwriter,xsl --version="$phpvn"
selectorctl --replace-extensions=bcmath,dom,fileinfo,gd,gmp,intl,mbstring,mysqlnd,nd_mysqli,pdo,pdo_mysql,pdo_sqlite,phar,posix,snmp,soap,sockets,tidy,xmlreader,xmlwriter,xsl,zip --version="$phpvn"

# 調整 php.ini 設定
sed -i 's/^expose_php.*.=.*/expose_php = Off/g' /opt/alt/"$phpv"/etc/php.ini
sed -i 's/^log_errors.*.=.*/log_errors = Off/g' /opt/alt/"$phpv"/etc/php.ini
sed -i 's/^enable_dl.*.=.*/enable_dl = Off/g' /opt/alt/"$phpv"/etc/php.ini
sed -i 's/^disable_functions.*.=.*/disable_functions = symlink,show_source, system, exec, shell_exec, passthru, popen, proc_open, proc_close, proc_get_status, proc_nice, proc_terminate, escapeshellarg, escapeshellcmd, ini_alter, define_syslog_variables,posix_uname,posix_getpwuid,posix_getpwnam, apache_child_terminate,posix_kill,posix_mkfifo,posix_setpgid,posix_setsid,posix_setuid,proc_terminate, posix_uname, diskfreespace, leak,base64_encodem,eval, apache_child_terminate, apache_setenv/g' /opt/alt/"$phpv"/etc/php.ini
sed -i 's/date\.timezone.*.=.*/date\.timezone="Asia\/Taipei"/g' /opt/alt/"$phpv"/etc/php.ini
sed -i 's/^;memory_limit.*.=.*/memory_limit = 128M/g' /opt/alt/"$phpv"/etc/php.ini
sed -i 's/^upload_max_filesize.*/upload_max_filesize = 32M/g' /opt/alt/"$phpv"/etc/php.ini
cagefsctl --force-update
